* SLHARead.F
* read a file in SUSY Les Houches Accord format (hep-ph/0311123)
* last modified 20 Mar 07 th

#include "PDG.h"
#include "SLHAIntern.h"


	subroutine SLHARead(error, sd, filename, abort)
	implicit none
	integer error, abort
	double precision sd(*)
	character*(*) filename

	integer lnblnk, SLHATokens
	external lnblnk, SLHATokens

	integer lineno, block, im, n, n1, n2, n3, pdgno
	integer decay, parent, parent_id, i, id(10)
	double precision blockQ, val

	integer m
	parameter (m = 2**30 - 1)

#define Range(i,min,max) \
iand(max-i,m).le.max-min

#define Vector(x,n1,max) \
if( Range(n1,1,max) ) x(n1)

#define Matrix(x,n1,n2,max) \
if( Range(n1,1,max).and.Range(n2,1,max) ) x(n1,n2)

#define Triple(x,n1,n2,n3,max) \
if( Range(n1,1,max).and.Range(n2,1,max).and.Range(n3,1,max) ) x(n1,n2,n3)

#define Scan \
read(line, *, err=998, end=998)

	character*200 line

#include "SLHAReadBlocks.h"

	error = 0
	call SLHAClear(sd)

	open(10, file=filename, status="old", err=997)
	lineno = 0
	block = 0
	decay = 1
	pdgno = 0

100	format(A)
101	format(A, I5)
102	format(A, A, A, I5)
103	format(A, A)

500	continue
	lineno = lineno + 1
	read(10, 100, end=999) line
	if( SLHATokens(line) .eq. 0 ) goto 500

	if( line(1:6) .eq. "BLOCK " ) then
	  i = 7
	  im = 1
	  if( line(7:8) .eq. "IM" ) then
	    im = 2
	    i = 9
	  endif
	  n = index(line(i:), " ")

	  do block = 1, nblocks
	    if( line(i:i+n-1) .eq. blockname(block)(1:n) ) then
	      blockQ = 0
	      if( line(i+n:i+n+1) .eq. "Q=" )
     &          read(line(i+n+2:), *) blockQ
	      goto 500
	    endif
	  enddo
	  print 102, "Unknown block ", line(7:n+3+2*i),
     &      " in input line", lineno
	  block = -1
	  goto 500
	endif

	if( line(1:6) .eq. "DECAY " ) then
	  if( decay + 2 .ge. LengthDecay ) then
	    print 101, "Out of memory in input line", lineno
	    block = -1
	  else
	    block = tecys
	    read(line(7:), *, err=998, end=998) parent_id, val
	    parent = decay
	    decay = decay + 2
	    Decay(parent) = Decay_Entry(parent_id, 2)
	    Decay(parent + 1) = val
	  endif
	  goto 500
	endif

	goto (
     &    modse, sminp, minpa, extpa, mass, tmass, nmix, umix, vmix,
     &    staum, stopm, sbotm, alfa, talfa, hmix, gauge, msoft,
     &    ae, au, ad, ye, yu, yd, rli, rlpi, rlppi, rl, rlp, rlpp,
     &    rai, rapi, rappi, ra, rap, rapp, rki, rk, rdi, rd, rvevi,
     &    rvev, rmlhi, rmlh, rnmix, rumix, rvmix, rhmix, ramix,
     &    rlmix, vckmi, vckm, msl2i, mse2i, msq2i, msu2i, msd2i,
     &    msl2, mse2, msq2, msu2, msd2, snmix, slmix, usmix, tsmix,
     &    hcmix, nnmix, nhmix, namix, prcob, spinf, tcinf, tecys
     &  ) block

	if( block .eq. 0 ) then
	  if( abort .ne. 0 ) then
* depending on the abort flag, one can stop reading here and
* assume the file is in a different format...
	    error = 2
	    goto 999
	  endif
* ... or issue a warning and continue
	  print 101, "Superfluous text in input line", lineno
	endif

	goto 500

997	print 103, "Cannot open ", filename
	error = 1
	return

998	print 101, "Syntax error in input line", lineno
	goto 500

modse	Scan n, val
	if( n .eq. 1  ) ModSel_Model = val
	if( n .eq. 3  ) ModSel_Content = val
	if( n .eq. 4  ) ModSel_RPV = val
	if( n .eq. 5  ) ModSel_CPV = val
	if( n .eq. 6  ) ModSel_FV = val
	if( n .eq. 11 ) ModSel_GridPts = val
	if( n .eq. 12 ) ModSel_Qmax = val
	if( n .eq. 21 ) then
	  pdgno = pdgno + 1
	  if( pdgno .le. 5 ) ModSel_PDG(pdgno) = val
	endif
	goto 500

sminp	Scan n, val
	if( n .eq. 1  ) SMInputs_AlfaMZ = val
	if( n .eq. 2  ) SMInputs_GF = val
	if( n .eq. 3  ) SMInputs_AlfasMZ = val
	if( n .eq. 4  ) SMInputs_MZ = val
	if( n .eq. 5  ) SMInputs_Mb = val
	if( n .eq. 6  ) SMInputs_Mt = val
	if( n .eq. 7  ) SMInputs_Mtau = val
	if( n .eq. 8  ) SMInputs_Ms = val
	if( n .eq. 9  ) SMInputs_Mc = val
	if( n .eq. 10 ) SMInputs_Mmu = val
	if( n .eq. 11 ) SMInputs_Md = val
	if( n .eq. 12 ) SMInputs_Mu = val
	if( n .eq. 13 ) SMInputs_Me = val
	goto 500

minpa	Scan n, val
	if( n .eq. 1 ) MinPar_M0 = val
	if( n .eq. 2 ) MinPar_M12 = val
	if( n .eq. 3 ) MinPar_TB = val
	if( n .eq. 4 ) MinPar_signMUE = val
	if( n .eq. 5 ) MinPar_A = val
	if( n .eq. 6 ) MinPar_cgrav = val
	goto 500

extpa	Scan n, val
	if( n .eq. 0  ) ExtPar_Q = val
	if( n .eq. 1  ) ExtPar_M1 = val
	if( n .eq. 2  ) ExtPar_M2 = val
	if( n .eq. 3  ) ExtPar_M3 = val
	if( n .eq. 11 ) ExtPar_At = val
	if( n .eq. 12 ) ExtPar_Ab = val
	if( n .eq. 13 ) ExtPar_Atau = val
	if( n .eq. 21 ) ExtPar_MHd2 = val
	if( n .eq. 22 ) ExtPar_MHu2 = val
	if( n .eq. 23 ) ExtPar_MUE = val
	if( n .eq. 24 ) ExtPar_MA02 = val
	if( n .eq. 25 ) ExtPar_TB = val
	if( Range(n, 31, 33) ) ExtPar_MSL(n - 30) = val
	if( Range(n, 34, 36) ) ExtPar_MSE(n - 33) = val
	if( Range(n, 41, 43) ) ExtPar_MSQ(n - 40) = val
	if( Range(n, 44, 46) ) ExtPar_MSU(n - 43) = val
	if( Range(n, 47, 49) ) ExtPar_MSD(n - 46) = val
	if( Range(n, 51, 53) ) ExtPar_N5(n - 50) = val
	if( n .eq. 61 ) ExtPar_lambda = val
	if( n .eq. 62 ) ExtPar_kappa = val
	if( n .eq. 63 ) ExtPar_Alambda = val
	if( n .eq. 64 ) ExtPar_Akappa = val
	if( n .eq. 65 ) ExtPar_MUEeff = val
	goto 500

mass	Scan n, val
	if( n .eq. PDG_nu_e        ) Mass_Mf(1,1) = val
	if( n .eq. PDG_electron    ) Mass_Mf(2,1) = val
	if( n .eq. PDG_up          ) Mass_Mf(3,1) = val
	if( n .eq. PDG_down        ) Mass_Mf(4,1) = val
	if( n .eq. PDG_nu_mu       ) Mass_Mf(1,2) = val
	if( n .eq. PDG_muon        ) Mass_Mf(2,2) = val
	if( n .eq. PDG_charm       ) Mass_Mf(3,2) = val
	if( n .eq. PDG_strange     ) Mass_Mf(4,2) = val
	if( n .eq. PDG_nu_tau      ) Mass_Mf(1,3) = val
	if( n .eq. PDG_tau         ) Mass_Mf(2,3) = val
	if( n .eq. PDG_top         ) Mass_Mf(3,3) = val
	if( n .eq. PDG_bottom      ) Mass_Mf(4,3) = val
	if( n .eq. PDG_snu_e1      ) Mass_MSf(1,1,1) = val
	if( n .eq. PDG_snu_e2      ) Mass_MSf(2,1,1) = val
	if( n .eq. PDG_selectron1  ) Mass_MSf(1,2,1) = val
	if( n .eq. PDG_selectron2  ) Mass_MSf(2,2,1) = val
	if( n .eq. PDG_sup1        ) Mass_MSf(1,3,1) = val
	if( n .eq. PDG_sup2        ) Mass_MSf(2,3,1) = val
	if( n .eq. PDG_sdown1      ) Mass_MSf(1,4,1) = val
	if( n .eq. PDG_sdown2      ) Mass_MSf(2,4,1) = val
	if( n .eq. PDG_snu_mu1     ) Mass_MSf(1,1,2) = val
	if( n .eq. PDG_snu_mu2     ) Mass_MSf(2,1,2) = val
	if( n .eq. PDG_smuon1      ) Mass_MSf(1,2,2) = val
	if( n .eq. PDG_smuon2      ) Mass_MSf(2,2,2) = val
	if( n .eq. PDG_scharm1     ) Mass_MSf(1,3,2) = val
	if( n .eq. PDG_scharm2     ) Mass_MSf(2,3,2) = val
	if( n .eq. PDG_sstrange1   ) Mass_MSf(1,4,2) = val
	if( n .eq. PDG_sstrange2   ) Mass_MSf(2,4,2) = val
	if( n .eq. PDG_snu_tau1    ) Mass_MSf(1,1,3) = val
	if( n .eq. PDG_snu_tau2    ) Mass_MSf(2,1,3) = val
	if( n .eq. PDG_stau1       ) Mass_MSf(1,2,3) = val
	if( n .eq. PDG_stau2       ) Mass_MSf(2,2,3) = val
	if( n .eq. PDG_stop1       ) Mass_MSf(1,3,3) = val
	if( n .eq. PDG_stop2       ) Mass_MSf(2,3,3) = val
	if( n .eq. PDG_sbottom1    ) Mass_MSf(1,4,3) = val
	if( n .eq. PDG_sbottom2    ) Mass_MSf(2,4,3) = val
	if( n .eq. PDG_Z           ) Mass_MZ = val
	if( n .eq. PDG_W           ) Mass_MW = val
	if( n .eq. PDG_h0          ) Mass_Mh0 = val
	if( n .eq. PDG_HH          ) Mass_MHH = val
	if( n .eq. PDG_A0          ) Mass_MA0 = val
	if( n .eq. PDG_Hp          ) Mass_MHp = val
	if( n .eq. PDG_neutralino1 ) Mass_MNeu(1) = val
	if( n .eq. PDG_neutralino2 ) Mass_MNeu(2) = val
	if( n .eq. PDG_neutralino3 ) Mass_MNeu(3) = val
	if( n .eq. PDG_neutralino4 ) Mass_MNeu(4) = val
	if( n .eq. PDG_neutralino5 ) Mass_MNeu(5) = val
	if( n .eq. PDG_chargino1   ) Mass_MCha(1) = val
	if( n .eq. PDG_chargino2   ) Mass_MCha(2) = val
	if( n .eq. PDG_gluino      ) Mass_MGl = val
	if( n .eq. PDG_gravitino   ) Mass_MGrav = val
	goto 500

tmass	Scan n, val
	if( n .eq. PDG_h0 ) DMass_DeltaMh0 = val
	if( n .eq. PDG_HH ) DMass_DeltaMHH = val
	if( n .eq. PDG_A0 ) DMass_DeltaMA0 = val
	if( n .eq. PDG_Hp ) DMass_DeltaMHp = val
	goto 500

nmix	Scan n1, n2, val
	Matrix(NMix_ZNeu, n1,n2, 4) = val
	goto 500

umix	Scan n1, n2, val
	Matrix(UMix_UCha, n1,n2, 2) = val
	goto 500

vmix	Scan n1, n2, val
	Matrix(VMix_VCha, n1,n2, 2) = val
	goto 500

staum	Scan n1, n2, val
	Matrix(StauMix_USf, n1,n2, 2) = val
	goto 500

stopm	Scan n1, n2, val
	Matrix(StopMix_USf, n1,n2, 2) = val
	goto 500

sbotm	Scan n1, n2, val
	Matrix(SbotMix_USf, n1,n2, 2) = val
	goto 500

alfa	Scan Alpha_Alpha
	goto 500

talfa	Scan DAlpha_DeltaAlpha
	goto 500

hmix	Scan n, val
	HMix_Q = blockQ
	if( n .eq. 1 ) HMix_MUE = val
	if( n .eq. 2 ) HMix_TB = val
	if( n .eq. 3 ) HMix_VEV = val
	if( n .eq. 4 ) HMix_MA02 = val
	goto 500

gauge	Scan n, val
	Gauge_Q = blockQ
	if( n .eq. 1 ) Gauge_g1 = val
	if( n .eq. 2 ) Gauge_g2 = val
	if( n .eq. 3 ) Gauge_g3 = val
	goto 500

msoft	Scan n, val
	MSoft_Q = blockQ
	if( n .eq. 1  ) MSoft_M1 = val
	if( n .eq. 2  ) MSoft_M2 = val
	if( n .eq. 3  ) MSoft_M3 = val
	if( n .eq. 21 ) MSoft_MHd2 = val
	if( n .eq. 22 ) MSoft_MHu2 = val
	if( Range(n, 31, 33) ) MSoft_MSL(n - 30) = val
	if( Range(n, 34, 36) ) MSoft_MSE(n - 33) = val
	if( Range(n, 41, 43) ) MSoft_MSQ(n - 40) = val
	if( Range(n, 44, 46) ) MSoft_MSU(n - 43) = val
	if( Range(n, 47, 49) ) MSoft_MSD(n - 46) = val
	goto 500

ae	Scan n1, n2, val
	Ae_Q = blockQ
	Matrix(Ae_Af, n1,n2, 3) = val
	goto 500

au	Scan n1, n2, val
	Au_Q = blockQ
	Matrix(Au_Af, n1,n2, 3) = val
	goto 500

ad	Scan n1, n2, val
	Ad_Q = blockQ
	Matrix(Ad_Af, n1,n2, 3) = val
	goto 500

ye	Scan n1, n2, val
	Ye_Q = blockQ
	Matrix(Ye_Yf, n1,n2, 3) = val
	goto 500

yu	Scan n1, n2, val
	Yu_Q = blockQ
	Matrix(Yu_Yf, n1,n2, 3) = val
	goto 500

yd	Scan n1, n2, val
	Yd_Q = blockQ
	Matrix(Yd_Yf, n1,n2, 3) = val
	goto 500

rli	Scan n1, n2, n3, val
	Triple(RVLambdaIn_lambda, n1,n2,n3, 3) = val
	goto 500

rlpi	Scan n1, n2, n3, val
	Triple(RVLambdaPIn_lambdaP, n1,n2,n3, 3) = val
	goto 500

rlppi	Scan n1, n2, n3, val
	Triple(RVLambdaPPIn_lambdaPP, n1,n2,n3, 3) = val
	goto 500

rl	Scan n1, n2, n3, val
	RVLambda_Q = blockQ
	Triple(RVLambda_lambda, n1,n2,n3, 3) = val
	goto 500

rlp	Scan n1, n2, n3, val
	RVLambdaP_Q = blockQ
	Triple(RVLambdaP_lambdaP, n1,n2,n3, 3) = val
	goto 500

rlpp	Scan n1, n2, n3, val
	RVLambdaPP_Q = blockQ
	Triple(RVLambdaPP_lambdaPP, n1,n2,n3, 3) = val
	goto 500

rai	Scan n1, n2, n3, val
	Triple(RVAIn_A, n1,n2,n3, 3) = val
	goto 500

rapi	Scan n1, n2, n3, val
	Triple(RVAPIn_AP, n1,n2,n3, 3) = val
	goto 500

rappi	Scan n1, n2, n3, val
	Triple(RVAPPIn_APP, n1,n2,n3, 3) = val
	goto 500

ra	Scan n1, n2, n3, val
	RVA_Q = blockQ
	Triple(RVA_A, n1,n2,n3, 3) = val
	goto 500

rap	Scan n1, n2, n3, val
	RVAP_Q = blockQ
	Triple(RVAP_AP, n1,n2,n3, 3) = val
	goto 500

rapp	Scan n1, n2, n3, val
	RVAPP_Q = blockQ
	Triple(RVAPP_APP, n1,n2,n3, 3) = val
	goto 500

rki	Scan n, val
	Vector(RVKappaIn_kappa, n, 3) = val
	goto 500

rk	Scan n, val
	RVKappa_Q = blockQ
	Vector(RVKappa_kappa, n, 3) = val
	goto 500

rdi	Scan n, val
	Vector(RVDIn_D, n, 3) = val
	goto 500

rd	Scan n, val
	RVD_Q = blockQ
	Vector(RVD_D, n, 3) = val
	goto 500

rvevi	Scan n, val
	Vector(RVSnVEVIn_VEV, n, 3) = val
	goto 500

rvev	Scan n, val
	RVSnVEV_Q = blockQ
	Vector(RVSnVEV_VEV, n, 3) = val
	goto 500

rmlhi	Scan n, val
	Vector(RVMLH1SqIn_MLH12, n, 3) = val
	goto 500

rmlh	Scan n, val
	RVMLH1Sq_Q = blockQ
	Vector(RVMLH1Sq_MLH12, n, 3) = val
	goto 500

rnmix	Scan n1, n2, val
	Matrix(RVNMix_ZNeu, n1,n2, 7) = val
	goto 500

rumix	Scan n1, n2, val
	Matrix(RVUMix_UCha, n1,n2, 5) = val
	goto 500

rvmix	Scan n1, n2, val
	Matrix(RVVMix_VCha, n1,n2, 5) = val
	goto 500

rhmix	Scan n1, n2, val
	Matrix(RVHMix_UH, n1,n2, 5) = val
	goto 500

ramix	Scan n1, n2, val
	Matrix(RVAMix_UA, n1,n2, 5) = val
	goto 500

rlmix	Scan n1, n2, val
	Matrix(RVLMix_CLep, n1,n2, 8) = val
	goto 500

vckmi	Scan n, val
	if( n .eq. 1 ) VCKMInputs_theta12 = val
	if( n .eq. 2 ) VCKMInputs_theta23 = val
	if( n .eq. 3 ) VCKMInputs_theta13 = val
	if( n .eq. 4 ) VCKMInputs_delta13 = val
	goto 500

vckm	Scan n, val
	VCKM_Q = blockQ
	if( n .eq. 1 ) VCKM_theta12 = val
	if( n .eq. 2 ) VCKM_theta23 = val
	if( n .eq. 3 ) VCKM_theta13 = val
	if( n .eq. 4 ) VCKM_delta13 = val
	goto 500

msl2i	Scan n1, n2, val
	Matrix(MSL2In_MSL2, n1,n2, 3) = val
	goto 500

mse2i	Scan n1, n2, val
	Matrix(MSE2In_MSE2, n1,n2, 3) = val
	goto 500

msq2i	Scan n1, n2, val
	Matrix(MSQ2In_MSQ2, n1,n2, 3) = val
	goto 500

msu2i	Scan n1, n2, val
	Matrix(MSU2In_MSU2, n1,n2, 3) = val
	goto 500

msd2i	Scan n1, n2, val
	Matrix(MSD2In_MSD2, n1,n2, 3) = val
	goto 500

msl2	Scan n1, n2, val
	MSL2_Q = blockQ
	Matrix(MSL2_MSL2, n1,n2, 3) = val
	goto 500

mse2	Scan n1, n2, val
	MSE2_Q = blockQ
	Matrix(MSE2_MSE2, n1,n2, 3) = val
	goto 500

msq2	Scan n1, n2, val
	MSQ2_Q = blockQ
	Matrix(MSQ2_MSQ2, n1,n2, 3) = val
	goto 500

msu2	Scan n1, n2, val
	MSU2_Q = blockQ
	Matrix(MSU2_MSU2, n1,n2, 3) = val
	goto 500

msd2	Scan n1, n2, val
	MSD2_Q = blockQ
	Matrix(MSD2_MSD2, n1,n2, 3) = val
	goto 500

snmix	Scan n1, n2, val
	Matrix(SnMix_UASf, n1,n2, 6) = val
	goto 500

slmix	Scan n1, n2, val
	Matrix(SlMix_UASf, n1,n2, 6) = val
	goto 500

usmix	Scan n1, n2, val
	Matrix(USqMix_UASf, n1,n2, 6) = val
	goto 500

tsmix	Scan n1, n2, val
	Matrix(DSqMix_UASf, n1,n2, 6) = val
	goto 500

hcmix	Scan n1, n2, val
	Matrix(CVHMix_UH, n1,n2, 4) = val
	goto 500

nnmix	Scan n1, n2, val
	Matrix(NMNMix_ZNeu, n1,n2, 5) = val
	goto 500

nhmix	Scan n1, n2, val
	Matrix(NMHMix_UH, n1,n2, 3) = val
	goto 500

namix	Scan n1, n2, val
	Matrix(NMAMix_UA, n1,n2, 3) = val
	goto 500

prcob	Scan n, val
	if( n .eq. 1  ) PrecObs_DeltaRho = val
	if( n .eq. 2  ) PrecObs_MWMSSM = val
	if( n .eq. 3  ) PrecObs_MWSM = val
	if( n .eq. 4  ) PrecObs_SW2effMSSM = val
	if( n .eq. 5  ) PrecObs_SW2effSM = val
	if( n .eq. 11 ) PrecObs_gminus2mu = val
	if( n .eq. 21 ) PrecObs_EDMeTh = val
	if( n .eq. 22 ) PrecObs_EDMn = val
	if( n .eq. 23 ) PrecObs_EDMHg = val
	if( n .eq. 31 ) PrecObs_bsgammaMSSM = val
	if( n .eq. 32 ) PrecObs_bsgammaSM = val
	goto 500

spinf	Scan n
	SPInfo_Severity = max(int(SPInfo_Severity), n)
	goto 500

tcinf	Scan n
	DCInfo_Severity = max(int(DCInfo_Severity), n)
	goto 500

tecys	Scan val, n, (id(i), i = 1, n)
	if( val .eq. 0 ) goto 500
	if( decay + n + 1 .ge. LengthDecay ) then
	  print 101, "Out of memory in input line", lineno
	  block = -1
	else
	  do i = 1, n
	    Decay(decay) = Decay_Entry(id(i), n + 1)
	    decay = decay + 1
	  enddo
	  Decay(decay) = val
	  decay = decay + 1
	  Decay(parent) = Decay_Entry(parent_id, decay - parent)
	endif
	goto 500

999	close(10)
	end


************************************************************************
	
	integer function SLHATokens(s)
	implicit none
	character*(*) s

	integer si, di, c

	SLHATokens = 0
	di = 0
	do si = 1, len(s)
	  c = ichar(s(si:si))
	  if( c .eq. ichar('#') ) goto 1
	  if( c .eq. ichar(' ') .or. c .eq. 9 ) then
	    if( di .ne. 0 .and.
     &          s(di:di) .ne. ' ' .and. s(di:di) .ne. '=' ) then
	      SLHATokens = SLHATokens + 1
	      di = di + 1
	      s(di:di) = ' '
	    endif
	  else
	    if( c .ne. ichar('=') .or.
     &          di .eq. 0 .or. s(di:di) .ne. ' ' )
     &        di = di + 1
	    if( c .gt. 96 ) c = iand(c, 223)
	    s(di:di) = char(c)
	  endif
	enddo

1	do si = di + 1, len(s)
	  s(si:si) = ' '
	enddo
	end

